<!DOCTYPE HTML>
<html lang="en">
<head>
<!-- Generated by javadoc (21) -->
<title>Source code</title>
<meta name="viewport" content="width=device-width, initial-scale=1">
<meta name="description" content="source: package: org.apache.commons.cli, class: TypeHandler">
<meta name="generator" content="javadoc/SourceToHTMLConverter">
<link rel="stylesheet" type="text/css" href="../../../../../stylesheet.css" title="Style">
</head>
<body class="source-page">
<main role="main">
<div class="source-container">
<pre><span class="source-line-no">001</span><span id="line-1">/*</span>
<span class="source-line-no">002</span><span id="line-2">  Licensed to the Apache Software Foundation (ASF) under one or more</span>
<span class="source-line-no">003</span><span id="line-3">  contributor license agreements.  See the NOTICE file distributed with</span>
<span class="source-line-no">004</span><span id="line-4">  this work for additional information regarding copyright ownership.</span>
<span class="source-line-no">005</span><span id="line-5">  The ASF licenses this file to You under the Apache License, Version 2.0</span>
<span class="source-line-no">006</span><span id="line-6">  (the "License"); you may not use this file except in compliance with</span>
<span class="source-line-no">007</span><span id="line-7">  the License.  You may obtain a copy of the License at</span>
<span class="source-line-no">008</span><span id="line-8"></span>
<span class="source-line-no">009</span><span id="line-9">      http://www.apache.org/licenses/LICENSE-2.0</span>
<span class="source-line-no">010</span><span id="line-10"></span>
<span class="source-line-no">011</span><span id="line-11">  Unless required by applicable law or agreed to in writing, software</span>
<span class="source-line-no">012</span><span id="line-12">  distributed under the License is distributed on an "AS IS" BASIS,</span>
<span class="source-line-no">013</span><span id="line-13">  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.</span>
<span class="source-line-no">014</span><span id="line-14">  See the License for the specific language governing permissions and</span>
<span class="source-line-no">015</span><span id="line-15">  limitations under the License.</span>
<span class="source-line-no">016</span><span id="line-16"> */</span>
<span class="source-line-no">017</span><span id="line-17"></span>
<span class="source-line-no">018</span><span id="line-18">package org.apache.commons.cli;</span>
<span class="source-line-no">019</span><span id="line-19"></span>
<span class="source-line-no">020</span><span id="line-20">import java.io.File;</span>
<span class="source-line-no">021</span><span id="line-21">import java.io.FileInputStream;</span>
<span class="source-line-no">022</span><span id="line-22">import java.io.FileNotFoundException;</span>
<span class="source-line-no">023</span><span id="line-23">import java.net.MalformedURLException;</span>
<span class="source-line-no">024</span><span id="line-24">import java.net.URL;</span>
<span class="source-line-no">025</span><span id="line-25">import java.util.Date;</span>
<span class="source-line-no">026</span><span id="line-26"></span>
<span class="source-line-no">027</span><span id="line-27">/**</span>
<span class="source-line-no">028</span><span id="line-28"> * This is a temporary implementation. TypeHandler will handle the pluggableness of OptionTypes and it will direct all</span>
<span class="source-line-no">029</span><span id="line-29"> * of these types of conversion functionalities to ConvertUtils component in Commons already. BeanUtils I think.</span>
<span class="source-line-no">030</span><span id="line-30"> */</span>
<span class="source-line-no">031</span><span id="line-31">public class TypeHandler {</span>
<span class="source-line-no">032</span><span id="line-32">    /**</span>
<span class="source-line-no">033</span><span id="line-33">     * Returns the class whose name is {@code className}.</span>
<span class="source-line-no">034</span><span id="line-34">     *</span>
<span class="source-line-no">035</span><span id="line-35">     * @param className the class name</span>
<span class="source-line-no">036</span><span id="line-36">     * @return The class if it is found</span>
<span class="source-line-no">037</span><span id="line-37">     * @throws ParseException if the class could not be found</span>
<span class="source-line-no">038</span><span id="line-38">     */</span>
<span class="source-line-no">039</span><span id="line-39">    public static Class&lt;?&gt; createClass(final String className) throws ParseException {</span>
<span class="source-line-no">040</span><span id="line-40">        try {</span>
<span class="source-line-no">041</span><span id="line-41">            return Class.forName(className);</span>
<span class="source-line-no">042</span><span id="line-42">        } catch (final ClassNotFoundException e) {</span>
<span class="source-line-no">043</span><span id="line-43">            throw new ParseException("Unable to find the class: " + className);</span>
<span class="source-line-no">044</span><span id="line-44">        }</span>
<span class="source-line-no">045</span><span id="line-45">    }</span>
<span class="source-line-no">046</span><span id="line-46"></span>
<span class="source-line-no">047</span><span id="line-47">    /**</span>
<span class="source-line-no">048</span><span id="line-48">     * Returns the date represented by {@code str}.</span>
<span class="source-line-no">049</span><span id="line-49">     * &lt;p&gt;</span>
<span class="source-line-no">050</span><span id="line-50">     * This method is not yet implemented and always throws an {@link UnsupportedOperationException}.</span>
<span class="source-line-no">051</span><span id="line-51">     *</span>
<span class="source-line-no">052</span><span id="line-52">     * @param str the date string</span>
<span class="source-line-no">053</span><span id="line-53">     * @return The date if {@code str} is a valid date string, otherwise return null.</span>
<span class="source-line-no">054</span><span id="line-54">     * @throws UnsupportedOperationException always</span>
<span class="source-line-no">055</span><span id="line-55">     */</span>
<span class="source-line-no">056</span><span id="line-56">    public static Date createDate(final String str) {</span>
<span class="source-line-no">057</span><span id="line-57">        throw new UnsupportedOperationException("Not yet implemented");</span>
<span class="source-line-no">058</span><span id="line-58">    }</span>
<span class="source-line-no">059</span><span id="line-59"></span>
<span class="source-line-no">060</span><span id="line-60">    /**</span>
<span class="source-line-no">061</span><span id="line-61">     * Returns the File represented by {@code str}.</span>
<span class="source-line-no">062</span><span id="line-62">     *</span>
<span class="source-line-no">063</span><span id="line-63">     * @param str the File location</span>
<span class="source-line-no">064</span><span id="line-64">     * @return The file represented by {@code str}.</span>
<span class="source-line-no">065</span><span id="line-65">     */</span>
<span class="source-line-no">066</span><span id="line-66">    public static File createFile(final String str) {</span>
<span class="source-line-no">067</span><span id="line-67">        return new File(str);</span>
<span class="source-line-no">068</span><span id="line-68">    }</span>
<span class="source-line-no">069</span><span id="line-69"></span>
<span class="source-line-no">070</span><span id="line-70">    /**</span>
<span class="source-line-no">071</span><span id="line-71">     * Returns the File[] represented by {@code str}.</span>
<span class="source-line-no">072</span><span id="line-72">     * &lt;p&gt;</span>
<span class="source-line-no">073</span><span id="line-73">     * This method is not yet implemented and always throws an {@link UnsupportedOperationException}.</span>
<span class="source-line-no">074</span><span id="line-74">     *</span>
<span class="source-line-no">075</span><span id="line-75">     * @param str the paths to the files</span>
<span class="source-line-no">076</span><span id="line-76">     * @return The File[] represented by {@code str}.</span>
<span class="source-line-no">077</span><span id="line-77">     * @throws UnsupportedOperationException always</span>
<span class="source-line-no">078</span><span id="line-78">     */</span>
<span class="source-line-no">079</span><span id="line-79">    public static File[] createFiles(final String str) {</span>
<span class="source-line-no">080</span><span id="line-80">        // to implement/port:</span>
<span class="source-line-no">081</span><span id="line-81">        // return FileW.findFiles(str);</span>
<span class="source-line-no">082</span><span id="line-82">        throw new UnsupportedOperationException("Not yet implemented");</span>
<span class="source-line-no">083</span><span id="line-83">    }</span>
<span class="source-line-no">084</span><span id="line-84"></span>
<span class="source-line-no">085</span><span id="line-85">    /**</span>
<span class="source-line-no">086</span><span id="line-86">     * Create a number from a String. If a '.' is present, it creates a Double, otherwise a Long.</span>
<span class="source-line-no">087</span><span id="line-87">     *</span>
<span class="source-line-no">088</span><span id="line-88">     * @param str the value</span>
<span class="source-line-no">089</span><span id="line-89">     * @return the number represented by {@code str}</span>
<span class="source-line-no">090</span><span id="line-90">     * @throws ParseException if {@code str} is not a number</span>
<span class="source-line-no">091</span><span id="line-91">     */</span>
<span class="source-line-no">092</span><span id="line-92">    public static Number createNumber(final String str) throws ParseException {</span>
<span class="source-line-no">093</span><span id="line-93">        try {</span>
<span class="source-line-no">094</span><span id="line-94">            if (str.indexOf('.') != -1) {</span>
<span class="source-line-no">095</span><span id="line-95">                return Double.valueOf(str);</span>
<span class="source-line-no">096</span><span id="line-96">            }</span>
<span class="source-line-no">097</span><span id="line-97">            return Long.valueOf(str);</span>
<span class="source-line-no">098</span><span id="line-98">        } catch (final NumberFormatException e) {</span>
<span class="source-line-no">099</span><span id="line-99">            throw new ParseException(e.getMessage());</span>
<span class="source-line-no">100</span><span id="line-100">        }</span>
<span class="source-line-no">101</span><span id="line-101">    }</span>
<span class="source-line-no">102</span><span id="line-102"></span>
<span class="source-line-no">103</span><span id="line-103">    /**</span>
<span class="source-line-no">104</span><span id="line-104">     * Create an Object from the class name and empty constructor.</span>
<span class="source-line-no">105</span><span id="line-105">     *</span>
<span class="source-line-no">106</span><span id="line-106">     * @param className the argument value</span>
<span class="source-line-no">107</span><span id="line-107">     * @return the initialized object</span>
<span class="source-line-no">108</span><span id="line-108">     * @throws ParseException if the class could not be found or the object could not be created</span>
<span class="source-line-no">109</span><span id="line-109">     */</span>
<span class="source-line-no">110</span><span id="line-110">    public static Object createObject(final String className) throws ParseException {</span>
<span class="source-line-no">111</span><span id="line-111">        final Class&lt;?&gt; cl;</span>
<span class="source-line-no">112</span><span id="line-112"></span>
<span class="source-line-no">113</span><span id="line-113">        try {</span>
<span class="source-line-no">114</span><span id="line-114">            cl = Class.forName(className);</span>
<span class="source-line-no">115</span><span id="line-115">        } catch (final ClassNotFoundException cnfe) {</span>
<span class="source-line-no">116</span><span id="line-116">            throw new ParseException("Unable to find the class: " + className);</span>
<span class="source-line-no">117</span><span id="line-117">        }</span>
<span class="source-line-no">118</span><span id="line-118"></span>
<span class="source-line-no">119</span><span id="line-119">        try {</span>
<span class="source-line-no">120</span><span id="line-120">            return cl.getConstructor().newInstance();</span>
<span class="source-line-no">121</span><span id="line-121">        } catch (final Exception e) {</span>
<span class="source-line-no">122</span><span id="line-122">            throw new ParseException(e.getClass().getName() + "; Unable to create an instance of: " + className);</span>
<span class="source-line-no">123</span><span id="line-123">        }</span>
<span class="source-line-no">124</span><span id="line-124">    }</span>
<span class="source-line-no">125</span><span id="line-125"></span>
<span class="source-line-no">126</span><span id="line-126">    /**</span>
<span class="source-line-no">127</span><span id="line-127">     * Returns the URL represented by {@code str}.</span>
<span class="source-line-no">128</span><span id="line-128">     *</span>
<span class="source-line-no">129</span><span id="line-129">     * @param str the URL string</span>
<span class="source-line-no">130</span><span id="line-130">     * @return The URL in {@code str} is well-formed</span>
<span class="source-line-no">131</span><span id="line-131">     * @throws ParseException if the URL in {@code str} is not well-formed</span>
<span class="source-line-no">132</span><span id="line-132">     */</span>
<span class="source-line-no">133</span><span id="line-133">    public static URL createURL(final String str) throws ParseException {</span>
<span class="source-line-no">134</span><span id="line-134">        try {</span>
<span class="source-line-no">135</span><span id="line-135">            return new URL(str);</span>
<span class="source-line-no">136</span><span id="line-136">        } catch (final MalformedURLException e) {</span>
<span class="source-line-no">137</span><span id="line-137">            throw new ParseException("Unable to parse the URL: " + str);</span>
<span class="source-line-no">138</span><span id="line-138">        }</span>
<span class="source-line-no">139</span><span id="line-139">    }</span>
<span class="source-line-no">140</span><span id="line-140"></span>
<span class="source-line-no">141</span><span id="line-141">    /**</span>
<span class="source-line-no">142</span><span id="line-142">     * Returns the {@code Object} of type {@code clazz} with the value of {@code str}.</span>
<span class="source-line-no">143</span><span id="line-143">     *</span>
<span class="source-line-no">144</span><span id="line-144">     * @param str the command line value</span>
<span class="source-line-no">145</span><span id="line-145">     * @param clazz the class representing the type of argument</span>
<span class="source-line-no">146</span><span id="line-146">     * @param &lt;T&gt; type of argument</span>
<span class="source-line-no">147</span><span id="line-147">     * @return The instance of {@code clazz} initialized with the value of {@code str}.</span>
<span class="source-line-no">148</span><span id="line-148">     * @throws ParseException if the value creation for the given class failed</span>
<span class="source-line-no">149</span><span id="line-149">     */</span>
<span class="source-line-no">150</span><span id="line-150">    @SuppressWarnings("unchecked") // returned value will have type T because it is fixed by clazz</span>
<span class="source-line-no">151</span><span id="line-151">    public static &lt;T&gt; T createValue(final String str, final Class&lt;T&gt; clazz) throws ParseException {</span>
<span class="source-line-no">152</span><span id="line-152">        if (PatternOptionBuilder.STRING_VALUE == clazz) {</span>
<span class="source-line-no">153</span><span id="line-153">            return (T) str;</span>
<span class="source-line-no">154</span><span id="line-154">        }</span>
<span class="source-line-no">155</span><span id="line-155">        if (PatternOptionBuilder.OBJECT_VALUE == clazz) {</span>
<span class="source-line-no">156</span><span id="line-156">            return (T) createObject(str);</span>
<span class="source-line-no">157</span><span id="line-157">        }</span>
<span class="source-line-no">158</span><span id="line-158">        if (PatternOptionBuilder.NUMBER_VALUE == clazz) {</span>
<span class="source-line-no">159</span><span id="line-159">            return (T) createNumber(str);</span>
<span class="source-line-no">160</span><span id="line-160">        }</span>
<span class="source-line-no">161</span><span id="line-161">        if (PatternOptionBuilder.DATE_VALUE == clazz) {</span>
<span class="source-line-no">162</span><span id="line-162">            return (T) createDate(str);</span>
<span class="source-line-no">163</span><span id="line-163">        }</span>
<span class="source-line-no">164</span><span id="line-164">        if (PatternOptionBuilder.CLASS_VALUE == clazz) {</span>
<span class="source-line-no">165</span><span id="line-165">            return (T) createClass(str);</span>
<span class="source-line-no">166</span><span id="line-166">        }</span>
<span class="source-line-no">167</span><span id="line-167">        if (PatternOptionBuilder.FILE_VALUE == clazz) {</span>
<span class="source-line-no">168</span><span id="line-168">            return (T) createFile(str);</span>
<span class="source-line-no">169</span><span id="line-169">        }</span>
<span class="source-line-no">170</span><span id="line-170">        if (PatternOptionBuilder.EXISTING_FILE_VALUE == clazz) {</span>
<span class="source-line-no">171</span><span id="line-171">            return (T) openFile(str);</span>
<span class="source-line-no">172</span><span id="line-172">        }</span>
<span class="source-line-no">173</span><span id="line-173">        if (PatternOptionBuilder.FILES_VALUE == clazz) {</span>
<span class="source-line-no">174</span><span id="line-174">            return (T) createFiles(str);</span>
<span class="source-line-no">175</span><span id="line-175">        }</span>
<span class="source-line-no">176</span><span id="line-176">        if (PatternOptionBuilder.URL_VALUE == clazz) {</span>
<span class="source-line-no">177</span><span id="line-177">            return (T) createURL(str);</span>
<span class="source-line-no">178</span><span id="line-178">        }</span>
<span class="source-line-no">179</span><span id="line-179">        throw new ParseException("Unable to handle the class: " + clazz);</span>
<span class="source-line-no">180</span><span id="line-180">    }</span>
<span class="source-line-no">181</span><span id="line-181"></span>
<span class="source-line-no">182</span><span id="line-182">    /**</span>
<span class="source-line-no">183</span><span id="line-183">     * Returns the {@code Object} of type {@code obj} with the value of {@code str}.</span>
<span class="source-line-no">184</span><span id="line-184">     *</span>
<span class="source-line-no">185</span><span id="line-185">     * @param str the command line value</span>
<span class="source-line-no">186</span><span id="line-186">     * @param obj the type of argument</span>
<span class="source-line-no">187</span><span id="line-187">     * @return The instance of {@code obj} initialized with the value of {@code str}.</span>
<span class="source-line-no">188</span><span id="line-188">     * @throws ParseException if the value creation for the given object type failed</span>
<span class="source-line-no">189</span><span id="line-189">     */</span>
<span class="source-line-no">190</span><span id="line-190">    public static Object createValue(final String str, final Object obj) throws ParseException {</span>
<span class="source-line-no">191</span><span id="line-191">        return createValue(str, (Class&lt;?&gt;) obj);</span>
<span class="source-line-no">192</span><span id="line-192">    }</span>
<span class="source-line-no">193</span><span id="line-193"></span>
<span class="source-line-no">194</span><span id="line-194">    /**</span>
<span class="source-line-no">195</span><span id="line-195">     * Returns the opened FileInputStream represented by {@code str}.</span>
<span class="source-line-no">196</span><span id="line-196">     *</span>
<span class="source-line-no">197</span><span id="line-197">     * @param str the file location</span>
<span class="source-line-no">198</span><span id="line-198">     * @return The file input stream represented by {@code str}.</span>
<span class="source-line-no">199</span><span id="line-199">     * @throws ParseException if the file is not exist or not readable</span>
<span class="source-line-no">200</span><span id="line-200">     */</span>
<span class="source-line-no">201</span><span id="line-201">    public static FileInputStream openFile(final String str) throws ParseException {</span>
<span class="source-line-no">202</span><span id="line-202">        try {</span>
<span class="source-line-no">203</span><span id="line-203">            return new FileInputStream(str);</span>
<span class="source-line-no">204</span><span id="line-204">        } catch (final FileNotFoundException e) {</span>
<span class="source-line-no">205</span><span id="line-205">            throw new ParseException("Unable to find file: " + str);</span>
<span class="source-line-no">206</span><span id="line-206">        }</span>
<span class="source-line-no">207</span><span id="line-207">    }</span>
<span class="source-line-no">208</span><span id="line-208">}</span>




























































</pre>
</div>
</main>
</body>
</html>
